import math
from axelrod.action import Action
from axelrod.player import Player
IllllIIIlII, IllIIlIIII = Action.C, Action.D
class llIlIIlIlllIlIl(Player):
    IlIllIII = {
        "stochastic": False,
        "memory_depth": float("inf"),  
        "long_run_time": False,
        "inspects_source": False,
        "manipulates_source": False,
        "manipulates_state": False,
    }
    def IIIlIlIllIlllllIIIIl(lIlIIlll, llIllIlIlIIl: Player) -> Action:
        if len(llIllIlIlIIl.history) == 0:
            return IllllIIIlII
        if not llIllIlIlIIl.IllIIlIllllIlllII:
            return IllIIlIIII
        IIIIlIlllI = llIllIlIlIIl.IIIIlIlllI + lIlIIlll.IIIIlIlllI
        IllIIlIllllIlllII = llIllIlIlIIl.IllIIlIllllIlllII + lIlIIlll.IllIIlIllllIlllII
        if IIIIlIlllI / IllIIlIllllIlllII > lIlIIlll.IllllllllIllI:
            return IllIIlIIII
        return IllllIIIlII
class IllllIlllIIlIII(llIlIIlIlllIlIl):
    IlIIIIllIIllllII = "strategy"
    IllllllllIllI = math.pi